unit CommHandle;

interface

uses
  Windows, Classes, Controls, Forms, contnrs, Rubies, CommX;

type
  TCommHandle = class(TObject)
  public
    procedure doReceive(Sender: TObject;ReceiveSize:integer);
    procedure doBreak(Sender: TObject);
    procedure doError(Sender: TObject; ErrorState: Integer);
  end;

var
  id_init: Tid;
  rb_eCommError, cComm: Tvalue;

implementation

uses Pythia;

procedure TCommHandle.doReceive(Sender: TObject;ReceiveSize:integer);
var
  recv, data: Tvalue;
  errno: Integer;
begin
  recv := TComponent(Sender).tag;
  data := rb_ary_new;
  rb_ary_push(data, rb_intern('on_receive'));
  rb_ary_push(data, recv);
  rb_ary_push(data, INT2FIX(ReceiveSize));
  rb_protect(PhiCall, data, @errno);
  if errno <> 0 then PhiFail;
end;

procedure TCommHandle.doBreak(Sender: TObject);
var
  recv, data: Tvalue;
  errno: Integer;
begin
  recv := TComponent(Sender).tag;
  data := rb_ary_new;
  rb_ary_push(data, rb_intern('on_break'));
  rb_ary_push(data, recv);
  rb_protect(PhiCall, data, @errno);
  if errno <> 0 then PhiFail;
end;

procedure TCommHandle.doError(Sender: TObject; ErrorState: Integer);
var
  recv, data: Tvalue;
  errno: Integer;
begin
  recv := TComponent(Sender).tag;
  data := rb_ary_new;
  rb_ary_push(data, rb_intern('on_error'));
  rb_ary_push(data, recv);
  rb_ary_push(data, INT2FIX(ErrorState));
  rb_protect(PhiCall, data, @errno);
  if errno <> 0 then PhiFail;
end;

end.
